<template>
    <div>
        <NavLinks
            :links="links"
            :current="
                isChecked
                    ? isExist
                        ? textContent.nav.card_update
                        : textContent.nav.card_create
                    : ''
            "
        />

        <p>
            Прикрепите фото страницы с рукописным текстом: "Я ФИО настолько
            доверчивый что согласен на обработку моих паспортных и других личных
            данных" с датой и вашей подписью.
        </p>
        <QuestFileInput
            placeholder="Разрешение на обработку данных"
            :errors="errors.resolution"
            :src="documents.resolution.url"
            v-model="updatedDocuments.resolution"
            :disabled="isExist"
        />

        <QuestFileInput
            placeholder="Первая страница паспорта"
            :errors="errors.passport_first_page"
            :src="documents.passport_first_page.url"
            v-model="updatedDocuments.passport_first_page"
            :disabled="!isResolutionAdded"
        />

        <QuestFileInput
            placeholder="Вторая страница паспорта"
            :errors="errors.passport_second_page"
            :src="documents.passport_second_page.url"
            v-model="updatedDocuments.passport_second_page"
            :disabled="!isResolutionAdded"
        /><br />

        <QuestTextField
            placeholder="Имя"
            :errors="errors.first_name"
            v-model="updatedQuest.first_name"
            :disabled="!isResolutionAdded"
        /><br />

        <QuestTextField
            placeholder="Серия паспорта"
            :errors="errors.passport_series"
            v-model="updatedQuest.passport_series"
            :disabled="!isResolutionAdded"
        /><br />

        <QuestNumber
            placeholder="Дети"
            v-model="updatedQuest.children"
            :errors="errors.children"
            :disabled="!isResolutionAdded"
        /><br />
        <QuestCheckbox
            :disabled="!isResolutionAdded"
            placeholder="Отец"
            v-model="updatedQuest.father"
        />
        <br />

        <QuestMap v-model="updatedQuest" :disabled="!isResolutionAdded" />
        <br />

        <QuestTextField
            placeholder="Страна"
            :errors="errors.country"
            v-model="updatedQuest.country"
            :disabled="!isResolutionAdded"
        />
        <QuestBtn
            v-if="updatedQuest.country === 'Молдова'"
            @click="updatedQuest.country = 'Приднестровье'"
        >
            Заменить на "Приднестровье"
        </QuestBtn>
        <br />
        <QuestTextField
            placeholder="Город (Село, Посёлок)"
            :errors="errors.locality"
            v-model="updatedQuest.locality"
            :disabled="!isResolutionAdded"
        /><br />
        <QuestTextField
            placeholder="Район"
            :errors="errors.district"
            v-model="updatedQuest.district"
            :disabled="!isResolutionAdded"
        /><br />
        <QuestTextField
            placeholder="Улица"
            :errors="errors.street"
            v-model="updatedQuest.street"
            :disabled="!isResolutionAdded"
        /><br />
        <QuestTextField
            placeholder="Дом"
            :errors="errors.house"
            v-model="updatedQuest.house"
            :disabled="!isResolutionAdded"
        /><br />
        <br />
        <Selector
            placeholder="Факультет"
            v-model="updatedQuest.faculty_id"
            :items="facultiesData"
            :disabled="!isResolutionAdded"
        />
        <br />

        <Selector
            placeholder="Специальность"
            v-model="updatedQuest.speciality_id"
            :items="specialities"
            :disabled="!updatedQuest.faculty_id"
        />
        <br />
        <Selector
            placeholder="Форма обучения"
            v-model="updatedQuest.speciality_forma_id"
            :items="formas"
            :disabled="!updatedQuest.speciality_id"
        />
        <br />
        <Selector
            placeholder="Обучение на основе..."
            v-model="updatedQuest.speciality_basis_id"
            :items="basises"
            :disabled="!updatedQuest.speciality_id"
        /><br />
        <Selector
            placeholder="Язык обучения"
            v-model="updatedQuest.speciality_language_id"
            :items="languages"
            :disabled="!updatedQuest.speciality_id"
        />
        <br /><br />

        <QuestBtn
            v-if="!loading"
            :disabled="!isChanged || (!isExist && !isValid) || loading"
            @click="sendData"
        >
            {{ isExist ? "Сохранить изменения" : "Создать" }}
        </QuestBtn>
    </div>
</template>

<script>
import { mapActions, mapGetters, mapState } from "vuex";
import facultiesApi from "@/api/facultiesApi";
import Selector from "@/components/Selector";
import { getDiffs } from "@/utils";
import { prepDocuments } from "@/utils/documents";
import QuestFileInput from "@/components/QuestFileInput";
import QuestCheckbox from "@/components/Quests/QuestCheckbox";
import QuestNumber from "@/components/Quests/QuestNumber";
import QuestTextField from "@/components/QuestTextField";
import { prepErrors } from "@/utils";
import NavLinks from "@/components/NavLinks";
import { textContent } from "@/utils/textContent";
import QuestMap from "@/components/QuestMap";
import QuestBtn from "@/components/QuestBtn";
import snackbar from "@/utils/snackbar";

const initialUpdatedQuest = {
    faculty_id: null,
    speciality_id: null,
    speciality_forma_id: null,
    speciality_basis_id: null,
    speciality_language_id: null,
    /**/
    first_name: null,
    passport_series: null,
    children: null,
    father: null,
    /**/
    country: null,
    locality: null,
    district: null,
    street: null,
    house: null,
};

const initialUpdatedDocuments = {
    passport_first_page: null,
    passport_second_page: null,
    resolution: null,
};

export default {
    name: "QuestUpdate",
    components: {
        QuestBtn,
        QuestMap,
        NavLinks,
        QuestTextField,
        QuestNumber,
        QuestCheckbox,
        QuestFileInput,
        Selector,
    },
    props: {
        isAdmin: Boolean,
    },
    data: () => ({
        textContent,
        loading: true,
        updatedQuest: { ...initialUpdatedQuest },
        updatedDocuments: { ...initialUpdatedDocuments },
        facultiesData: [],
        isChecked: false,
        errors: {
            first_name: [],
            passport_first_page: [],
            passport_second_page: [],
            passport_series: [],
            children: [],
        },
    }),
    methods: {
        ...mapActions("quests", [
            "getMyQuest",
            "getQuest",
            "updateQuest",
            "createQuest",
        ]),

        async getData() {
            try {
                this.loading = true;

                !this.isAdmin
                    ? await this.getMyQuest()
                    : await this.getQuest(this.$route.params.id);
                if (this.currentQuest.is_approved)
                    this.$router.push(this.viewLink);
            } catch (e) {
                snackbar(e);
            } finally {
                this.isChecked = true;
                this.loading = false;
            }
        },
        async getFacultiesData() {
            try {
                this.facultiesData = await facultiesApi.getFacultyList();
            } catch (e) {
                snackbar(e);
            }
        },

        async sendData() {
            try {
                this.loading = true;
                const data = {
                    ...this.diffs,
                    faculty_id: this.updatedQuest.faculty_id,
                };
                this.isExist
                    ? await this.updateQuest({
                          data,
                          specialityId: this.updatedQuest.speciality_id,
                          questId: this.currentQuest.id,
                          isAdmin: this.isAdmin,
                      })
                    : await this.createQuest({
                          data,
                          specialityId: this.updatedQuest.speciality_id,
                      });
            } catch (e) {
                this.errors = prepErrors(e);
            } finally {
                this.loading = false;
            }
        },
    },
    computed: {
        ...mapState("quests", ["currentQuest"]),
        ...mapGetters("quests", ["isExist"]),
        isResolutionAdded() {
            return !!this.updatedDocuments.resolution || this.isExist;
        },
        isValid() {
            const { speciality_id, faculty_id } = this.updatedQuest;
            const {
                resolution,
                passport_first_page,
                passport_second_page,
            } = this.updatedDocuments;
            return !!(
                speciality_id &&
                faculty_id &&
                resolution &&
                passport_first_page &&
                passport_second_page
            );
        },
        viewLink() {
            return this.isAdmin
                ? {
                      name: "AdminQuestView",
                      params: { id: this.$route.params.id },
                  }
                : { name: "QuestView" };
        },
        specialities() {
            return (
                this.facultiesData.find(
                    ({ id }) => id === this.updatedQuest.faculty_id
                )?.specialities || []
            );
        },
        formas() {
            return (
                this.specialities.find(
                    ({ id }) => id === this.updatedQuest.speciality_id
                )?.formas || []
            );
        },
        languages() {
            return (
                this.specialities.find(
                    ({ id }) => id === this.updatedQuest.speciality_id
                )?.languages || []
            );
        },
        basises() {
            return (
                this.specialities.find(
                    ({ id }) => id === this.updatedQuest.speciality_id
                )?.basises || []
            );
        },
        diffs() {
            return getDiffs(
                {
                    ...(this.currentQuest || initialUpdatedQuest),
                    ...initialUpdatedDocuments,
                },
                { ...this.updatedQuest, ...this.updatedDocuments }
            );
        },
        isChanged() {
            return !!Object.entries(this.diffs).length;
        },
        documents() {
            return prepDocuments(this.updatedQuest);
        },
        links() {
            const welcomeLink = {
                text: textContent.nav.general,
                to: { name: "Welcome" },
            };

            const listLink = {
                text: textContent.nav.card_list,
                to: { name: "QuestList" },
            };

            const viewLink = {
                text: textContent.nav.card,
                to: this.viewLink,
            };

            return this.isAdmin
                ? [welcomeLink, listLink, viewLink]
                : [welcomeLink, viewLink];
        },
    },
    watch: {
        currentQuest(value) {
            if (value) {
                this.updatedQuest = { ...initialUpdatedQuest, ...value };
                this.updatedDocuments = { ...initialUpdatedDocuments };
            }
        },
        "updatedQuest.speciality_id"(value) {
            if (!this.loading) {
                const firstOrNull = (array) =>
                    array.length === 1 ? array[0].id : null;
                this.updatedQuest = {
                    ...this.updatedQuest,
                    speciality_forma_id: firstOrNull(this.formas),
                    speciality_basis_id: firstOrNull(this.basises),
                    speciality_language_id: firstOrNull(this.languages),
                    faculty_id: this.updatedQuest.faculty_id,
                    speciality_id: value,
                };
            }
        },
        "updatedQuest.faculty_id"(value) {
            if (!this.loading) {
                this.updatedQuest = {
                    ...this.updatedQuest,
                    speciality_forma_id: null,
                    speciality_basis_id: null,
                    speciality_language_id: null,
                    speciality_id: null,
                    faculty_id: value,
                };
            }
        },
    },
    async mounted() {
        await this.getData();
        await this.getFacultiesData();
    },
};
</script>

<style scoped></style>
